#include "app/GPUSlicerWindow.h"
#include "volume/GPUSlicer.h"
#include "transfunc/TransferFunction.h"
#include "core/ArcBall.h"
#include <time.h>
#include <GL/glut.h>

#define CLAMP(a,b,c) { b = ((b) < (a))? (a) : (((b) > (c))? (c): (b));}

CGPUSlicerWindow::CGPUSlicerWindow()
{
	m_bWireFrame = false;
	m_pGPUSlicer = new CGPUSlicer();
	m_pGPUSlicer->init();
	m_nMinValue = 0;
	m_nMaxValue = VTYPE_MAX;
}

CGPUSlicerWindow::~CGPUSlicerWindow(void)
{
	delete m_pGPUSlicer;
}

void
CGPUSlicerWindow::cgRenderGeometry() {
	
	m_pGPUSlicer->render();
	
}

void 
CGPUSlicerWindow::keyEvent(unsigned char key,int x,int y){

	switch (key) {
		case 'w':
			{
				m_pGPUSlicer->setWireframe(true);
			}
			break;
		case 'W':
			{
				m_pGPUSlicer->setWireframe(false);
			}
			break;
		case 'r':
		case 'R':
			{
				m_pArcBall->reset();
			}
			break;
		case 's':
			{
				m_pGPUSlicer->showOctree(true);
			}
			break;
		case 'S':
			{
				m_pGPUSlicer->showOctree(false);
			}
			break;
		case 'p':
			{
				m_nMinValue += 1;
				m_pGPUSlicer->setMin(m_nMinValue);
			}
			break;
		case 'P':
			{
				m_nMinValue -= 1;
				m_pGPUSlicer->setMin(m_nMinValue);
			}
			break;
			
		case 'm':
			{
				m_nMaxValue -= 1;
				m_pGPUSlicer->setMax(m_nMaxValue);
			}
			break;
		case 'M':
			{
				m_nMaxValue += 1;
				m_pGPUSlicer->setMax(m_nMaxValue);
			}
			break;
		case 't':
			{
				m_pGPUSlicer->showTF(true);
			}
			break;
		case 'T':
			{
				m_pGPUSlicer->showTF(false);
				
			}
			break;
		case 'a':
			{
				m_pGPUSlicer->initOctree(0,0,0);
			}
			break;
		case 'b':
			{
				m_pGPUSlicer->initOctree(1,1,0);
			}
			break;
		case 'c':
			{
				m_pGPUSlicer->initOctree(2,2,1);
			}
			break;
		case 'd':
			{
				m_pGPUSlicer->initOctree(4,4,2);
			}
			break;
		case 'e':
			{
				m_pGPUSlicer->initOctree(6,6,3);
			}
			break;
		case 'f':
			{
				m_pGPUSlicer->initOctree(7,7,3);
			}
			break;
	}

	glutPostRedisplay();
}

bool CGPUSlicerWindow::handleButtonEvent(int button, int state, int x, int y) {
	return m_pGPUSlicer->handleButtonEvent(button, state, x, m_nHeight-1-y);
}

bool CGPUSlicerWindow::handleMoveEvent(int x, int y) {
	return m_pGPUSlicer->handleMoveEvent(x,m_nHeight-1-y);
}