#include "volume\Block.h"
#include "mathutil\CVector.h"
#include <math.h>
#include <stdio.h>
#include <GL/gl.h>
#include <assert.h>
#include "core\GlutCgWindow.h"
//#define GL_GLEXT_PROTOTYPES
#include <GL/glext.h>
//#undef GL_GLEXT_PROTOTYPES

CBlock::CBlock()
{	
	m_pVertices[0] = CVector(-1.0,-1.0,-1.0,1.0);
	m_pVertices[1] = CVector( 1.0,-1.0,-1.0,1.0);
	m_pVertices[2] = CVector(-1.0, 1.0,-1.0,1.0);
	m_pVertices[3] = CVector( 1.0, 1.0,-1.0,1.0);

	m_pVertices[4] = CVector(-1.0,-1.0, 1.0, 1.0);
	m_pVertices[5] = CVector( 1.0,-1.0, 1.0, 1.0);
	m_pVertices[6] = CVector(-1.0, 1.0, 1.0, 1.0);
	m_pVertices[7] = CVector( 1.0, 1.0, 1.0, 1.0);
	m_vecTranslate.set(0.0,0.0,0.0,1.0);
}

void
CBlock::setVertices(const CVector *pVertices) {

	m_pVertices[0] = pVertices[0];
	m_pVertices[1] = pVertices[1];
	m_pVertices[2] = pVertices[2];
	m_pVertices[3] = pVertices[3];
					  
	m_pVertices[4] = pVertices[4];
	m_pVertices[5] = pVertices[5];
	m_pVertices[6] = pVertices[6];
	m_pVertices[7] = pVertices[7];

	m_vecTranslate.set(0.0,0.0,0.0,0.0);
	for(int i = 0; i < 8; ++i) {
		m_vecTranslate += m_pVertices[i];
	}
	m_vecTranslate = 1.0/8.0 * m_vecTranslate;

}


CBlock::~CBlock(void)
{
	
}

void 
CBlock::renderBoundingBox(int nMinIdx) {
	
	/*
	if (nMinIdx != -1) {
		glColor3f(1.0,1.0,0.0);
		glPointSize(4.0);
		glBegin(GL_POINTS);
		glVertex4dv(&(m_pVertices[nMinIdx][0]));
		glEnd();

	}*/
	
	glColor3f(0.0,0.0,0.0);
	glLineWidth(2.0);
	glBegin(GL_LINE_LOOP);
	{			
		glVertex4dv(&(m_pVertices[0][0]));
		glVertex4dv(&(m_pVertices[1][0]));
		glVertex4dv(&(m_pVertices[3][0]));
		glVertex4dv(&(m_pVertices[2][0]));
	}
	glEnd();
	glBegin(GL_LINE_LOOP);
	{			
		glVertex4dv(&(m_pVertices[4][0]));
		glVertex4dv(&(m_pVertices[5][0]));
		glVertex4dv(&(m_pVertices[7][0]));
		glVertex4dv(&(m_pVertices[6][0]));
	}
	glEnd();
	glBegin(GL_LINES);
	{			
		glVertex4dv(&(m_pVertices[0][0]));
		glVertex4dv(&(m_pVertices[4][0]));
		glVertex4dv(&(m_pVertices[1][0]));
		glVertex4dv(&(m_pVertices[5][0]));
		glVertex4dv(&(m_pVertices[3][0]));
		glVertex4dv(&(m_pVertices[7][0]));
		glVertex4dv(&(m_pVertices[2][0]));
		glVertex4dv(&(m_pVertices[6][0]));
	}
	glEnd();
	
}

void CBlock::activateForRendering(CGprogram vertexProgram) {

	cgGLSetParameter3dv( cgGetNamedParameter(vertexProgram,"vecTranslate"), &(m_vecTranslate[0]));

}

