#pragma once

#include "mathutil\CVector.h"

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>

#include "app\globaldefs.h"

class CBlock
{

public:

	CBlock();
	~CBlock(void);
	void renderBoundingBox(int nMinIdx = -1);
	void activateForRendering(CGprogram prog);
	void setVertices(const CVector *pvertices);
	inline VTYPE getMax() {return m_nMax;}
	inline VTYPE getMin() {return m_nMin;}
	inline void setMax(VTYPE max) {m_nMax = max;}
	inline void setMin(VTYPE min) {m_nMin = min;}

protected:
	CVector  m_pVertices[8];
	CVector  m_vecTranslate;

private:
	VTYPE m_nMin, m_nMax;

	friend class COctree;
};
