#pragma once

#include "mathutil\CVector.h"
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include "app\globaldefs.h"

class CBlock;
class COctree;

typedef CBlock *PLEAF;
typedef COctree *PSUBTREE;


class COctree
{

public:
	COctree(int nNumLevelsX, int nLevelX, 
				 int nNumLevelsY, int nLevelY, 
				 int nNumLevelsZ, int nLevelZ,  double xMin, double xMax, 
			double yMin, double yMax, double zMin, double zMax,
			VTYPE *pVolume, int nSizeX, int nSizeY, int nSizeZ); 

	void render(bool bBoundingBox = false);

	inline VTYPE getMin() {return m_nMinValue;}
	inline VTYPE getMax() {return m_nMaxValue;}

	static void prepareForRendering(int nFrontVertex, int nMaxNumSlices,
		double dSliceInc, 
		VTYPE nMinValue, VTYPE nMaxValue, 
		const CVector &camPos, 
		const CVector &viewVec, 
		CGprogram vertexProgram);

protected:
	CVector m_pVertices[8];
	bool m_bIsLeaf;

	VTYPE m_nMinValue;
	VTYPE m_nMaxValue;

	PSUBTREE	m_pChildren[8];
	PLEAF		m_pLeave;

	static VTYPE s_nMinValue;
	static VTYPE s_nMaxValue;
	static CVector s_vecView;
    static CVector s_vecCamPos;
	static CGprogram s_vertexProgram;
	static int s_nFrontVertex;
	static double s_dSliceInc;
	static int s_nMaxNumSlices;
	static GLuint s_nVertexBufferId;
	static GLuint s_nIndexBufferId;
	static bool s_bInit;
	static unsigned short *s_pIndexBuffer;

};
